import numpy as np

# Created by ChatGPT
def cubic_equation(a, b, c, d):
    a = np.array(a)
    b = np.array(b)
    c = np.array(c)
    d = np.array(d)

    # Calculate the coefficients
    p = (3 * c - b ** 2) / 3 / a ** 2
    q = (2 * b ** 3 - 9 * b * c + 27 * d) / 27 / a ** 3

    # Use the Cardano formula to find the roots
    u = ((q / 2) + np.sqrt(q ** 2 / 4 + p ** 3 / 27)) ** (1 / 3)
    v = ((q / 2) - np.sqrt(q ** 2 / 4 + p ** 3 / 27)) ** (1 / 3)

    # Calculate the roots
    root1 = (-1 / 3 * a) * (b / a + u + v)
    root2 = (-1 / 3 * a) * (b / a + u * np.exp(2j * np.pi / 3) + v * np.exp(-2j * np.pi / 3))
    root3 = (-1 / 3 * a) * (b / a + u * np.exp(-2j * np.pi / 3) + v * np.exp(2j * np.pi / 3))

    return root1, root2, root3

# Human corrected.
def cubic_equation_corrected(a, b, c, d):
    a = np.array(a)
    b = np.array(b)
    c = np.array(c)
    d = np.array(d)

    # Calculate the coefficients
    p = (3 * a * c - b ** 2) / 3 / a ** 2
    q = (2 * b ** 3 - 9 * a * b * c + 27 * a ** 2 * d) / 27 / a ** 3

    # Use the Cardano formula to find the roots
    delta = q ** 2 / 4 + p ** 3 / 27
    u3 = - q / 2 - np.emath.sqrt(delta)
    v3 = - q / 2 + np.emath.sqrt(delta)
    u = np.sign(u3) * np.abs(u3) ** (1 / 3)
    v = np.sign(v3) * np.abs(v3) ** (1 / 3)

    # Calculate the roots
    x0 = - b / 3 / a
    w = (-1 + np.sqrt(3) * 1j) / 2
    w2 = w ** 2
    root1 = x0 + u + v
    root2 = x0 + w * u + w2 * v
    root3 = x0 + w2 * u + w * v

    return root1, root2, root3

if __name__ == '__main__':
    print(cubic_equation([1.0], [1.0], [1.0], [1.0]))
