import numpy as np

def cubic_solve_multi(p):
	
    # Coefficients of quartic equation
    a, b, c = p[:, 1]/p[:, 0], p[:, 2]/p[:, 0], p[:, 3]/p[:, 0]
	
    # Construct the companion matrix
    A = np.zeros((len(a), 3, 3))
    A[:, 1:, :2] = np.eye(2)
    A[:, :, 2] = -np.array([c, b, a]).T
	
    # Compute roots using eigenvalues
    return np.linalg.eigvals(A)